summaryrefslogtreecommitdiffstats
path: root/package/uci/files
diff options
context:
space:
mode:
authorJo-Philipp Wich <jow@openwrt.org>2010-05-17 19:31:05 +0000
committerJo-Philipp Wich <jow@openwrt.org>2010-05-17 19:31:05 +0000
commit6efb515be1251b3a6dbb3ac1547070f8e57e68da (patch)
tree988819778e89f7cb34d84194e79f82b6195433c6 /package/uci/files
parent18a79362e9838f83ff3e01871750598d92b095bb (diff)
downloadmaster-31e0f0ae-6efb515be1251b3a6dbb3ac1547070f8e57e68da.tar.gz
master-31e0f0ae-6efb515be1251b3a6dbb3ac1547070f8e57e68da.tar.bz2
master-31e0f0ae-6efb515be1251b3a6dbb3ac1547070f8e57e68da.zip
uci: add uci_get() and uci_get_state() wrappers to shell api (#7312)
SVN-Revision: 21489
Diffstat (limited to 'package/uci/files')
-rw-r--r--package/uci/files/lib/config/uci.sh24
1 files changed, 21 insertions, 3 deletions
diff --git a/package/uci/files/lib/config/uci.sh b/package/uci/files/lib/config/uci.sh
index 851a0d779b..d759615bd5 100644
--- a/package/uci/files/lib/config/uci.sh
+++ b/package/uci/files/lib/config/uci.sh
@@ -1,6 +1,7 @@
#!/bin/sh
# Shell script compatibility wrappers for /sbin/uci
#
+# Copyright (C) 2008-2010 OpenWrt.org
# Copyright (C) 2008 Felix Fietkau <nbd@openwrt.org>
#
# This program is free software; you can redistribute it and/or modify
@@ -41,9 +42,9 @@ uci_load() {
uci_set_default() {
local PACKAGE="$1"
- /sbin/uci ${UCI_CONFIG_DIR:+-c $UCI_CONFIG_DIR} -q show "$1" > /dev/null && return 0
- /sbin/uci ${UCI_CONFIG_DIR:+-c $UCI_CONFIG_DIR} import "$1"
- /sbin/uci ${UCI_CONFIG_DIR:+-c $UCI_CONFIG_DIR} commit "$1"
+ /sbin/uci ${UCI_CONFIG_DIR:+-c $UCI_CONFIG_DIR} -q show "$PACKAGE" > /dev/null && return 0
+ /sbin/uci ${UCI_CONFIG_DIR:+-c $UCI_CONFIG_DIR} import "$PACKAGE"
+ /sbin/uci ${UCI_CONFIG_DIR:+-c $UCI_CONFIG_DIR} commit "$PACKAGE"
}
uci_revert_state() {
@@ -73,6 +74,23 @@ uci_set() {
/sbin/uci ${UCI_CONFIG_DIR:+-c $UCI_CONFIG_DIR} set "$PACKAGE.$CONFIG.$OPTION=$VALUE"
}
+uci_get_state() {
+ uci_get "$1" "$2" "$3" "$4" "/var/state"
+}
+
+uci_get() {
+ local PACKAGE="$1"
+ local CONFIG="$2"
+ local OPTION="$3"
+ local DEFAULT="$4"
+ local STATE="$5"
+
+ /sbin/uci ${UCI_CONFIG_DIR:+-c $UCI_CONFIG_DIR} ${STATE:+-P $STATE} -q get "$PACKAGE${CONFIG:+.$CONFIG}${OPTION:+.$OPTION}"
+ RET="$?"
+ [ "$RET" -ne 0 ] && [ -n "$DEFAULT" ] && echo "$DEFAULT"
+ return "$RET"
+}
+
uci_add() {
local PACKAGE="$1"
local TYPE="$2"